package ass.sivakfil.hw8.main;

import io.reactivex.Observable;

import java.io.IOException;
import java.net.SocketAddress;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.util.Iterator;

import ass.sivakfil.hw8.server.IRequestHandler;
import ass.sivakfil.hw8.server.IServer;

public class Server implements IServer {
	
	/**
	 * Address that server will bind to
	 */
	protected SocketAddress address;
	protected boolean exit = false;
	
	// TODO add some fields .. 
	
	public Server(SocketAddress address) {
		this.address = address;
	}
	
	public void run(IRequestHandler handler, String delimiter) throws IOException {
		// open, bind and configure ServerSocketChannel
		ServerSocketChannel serverChannel = ServerSocketChannel.open();
		serverChannel.bind(address);
		serverChannel.configureBlocking(false);

		System.out.println("Server started on address:" + address);
		
		// open selector and register serverSocketChannel to it
		Selector sel = Selector.open();
		serverChannel.register(sel, serverChannel.validOps());
		
		// use compose operator on RxJava Observable to handle requests using provided handler
		
		// start non-blocking loop
		while(!exit) {
			sel.select();
			Iterator<SelectionKey> iterator = sel.selectedKeys().iterator();
			Observable<SelectionKey> validKeys = Observable.<SelectionKey>create((emittor) -> {
				while(iterator.hasNext()) {
					SelectionKey next = iterator.next();
					emittor.onNext(next);
					iterator.remove();
				}
				emittor.onComplete();
			})
			.filter(key -> key.isValid())
			.cache();
			
			// using valid keys:
			
			// 1) clientChannel <- accept on acceptable key
			// 2) clientChannel.configureBlocking(false);
			// 3) clientChannel.register(selector, SelectionKey.OP_READ);
			// TODO
			
			// 1) (SocketChannel)key.channel() on readable key
			// 2) read from channel (you can use ByteBufferUtil)
			// 3) append data to some kind of buffer (ByteBuffer, ByteArrayOutputStream, StringBuilder, ...)
			// 4) construct request object when whole message is stored in buffer (message is terminated by terminator string)
			// 5) emit request object into observable 
			//	(hint: using PublishSubject is convenient)
			//	(PublishSubject is instantiated by calling PublishSubject.create())		
			// TODO
		}
	}

}
